unit FntNmPrp;

interface

uses
  Windows, Forms, Messages, SysUtils,
  Classes,DList,DsgnIntf,TypInfo,FntNmSet;

type
  TFontNameSetterEditor = class(TComponentEditor)
   function GetVerbCount : Integer ; override;
   function GetVerb(Index: integer) : String ; override;
   procedure ExecuteVerb(Index: integer);override;
  end;

  TNamesProperty = class(TClassProperty)
  private
   function GetAttributes : TPropertyAttributes; override;
   procedure Edit ; override;
  end;

  TTypesProperty = class(TNamesProperty)
  private
   procedure Edit ; override;
  end;


  procedure DeleteFromFirstIfNotInSecond(First,Second : TStrings);
  procedure DeleteFromFirstIfInSecond(First,Second : TStrings);

implementation

  { procedure }

  procedure DeleteFromFirstIfNotInSecond(First,Second : TStrings);
  var
   i : integer;
  begin
   i :=0;
   while i < First.Count do
    if (Second.IndexOf(First[i])= -1)
    then First.Delete(i)
    else inc(i);
  end;

  procedure DeleteFromFirstIfInSecond(First,Second : TStrings);
  var
   i : integer;
  begin
   i :=0;
   while i < First.Count do
    if (Second.IndexOf(First[i])<> -1)
    then First.Delete(i)
    else inc(i);
  end;
 {-----------}

 {---------  TFontNameSetterEditor  ----}
  function TFontNameSetterEditor.GetVerbCount : Integer ;
  begin
   Result := 1;
  end;

  function TFontNameSetterEditor.GetVerb(Index: integer) : String ;
  begin
   Result := 'Set FontName';
  end;

  procedure TFontNameSetterEditor.ExecuteVerb(Index: integer);
  begin
   (Component as TFontNameSetter).SetFontName;
  end;

  {---------  TNamesProperty  ----}
  function TNamesProperty.GetAttributes : TPropertyAttributes;
  begin
   Result := [paDialog];
  end;

  procedure TNamesProperty.Edit;
  var
   Dialog : TDListDialog;
   i: Integer;
   PropInfo: PPropInfo;
  begin
   Dialog := TDListDialog.Create(Application);
   try
    with Dialog do
    begin
     Title := 'Names Editor';
     Label1Caption := 'Selected Names';
     Label2Caption := 'Available Names';
     List1.BeginUpdate;
     List2.BeginUpdate;
     List1.Assign(TStrings(GetOrdValue));
     for i := 0 to Designer.Form.ComponentCount-1 do
      begin
       PropInfo := TypInfo.GetPropInfo(TComponent(GetComponent(0)).Owner.Components[I].ClassInfo, 'Font');
       if PropInfo <> nil then Dialog.List2.Add(TComponent(GetComponent(0)).Owner.Components[i].Name);
      end;
     Dialog.List2.Add(Designer.Form.Name);
     DeleteFromFirstIfNotInSecond(List1,List2);
     DeleteFromFirstIfInSecond(List2,List1);
     List1.EndUpdate;
     List2.EndUpdate;
     Execute;
     SetOrdValue(LongInt(List1));
    end;
   finally
    Dialog.Free;
   end;
  end;


  procedure TTypesProperty.Edit;
  var
   Dialog : TDListDialog;
   i: Integer;
   PropInfo: PPropInfo;
  begin
   Dialog := TDListDialog.Create(Application);
   try
    with Dialog do
    begin
     Title := 'Types Editor';
     Label1Caption := 'Selected Types';
     Label2Caption := 'Available Types';
     List1.BeginUpdate;
     List2.BeginUpdate;
     List1.Assign(TStrings(GetOrdValue));
     for i := 0 to Designer.Form.ComponentCount-1 do
      begin
       PropInfo := TypInfo.GetPropInfo(TComponent(GetComponent(0)).Owner.Components[I].ClassInfo, 'Font');
       if PropInfo <> nil then
       if (Dialog.List2.IndexOf(TComponent(GetComponent(0)).Owner.Components[i].ClassName)= -1)
       then Dialog.List2.Add(TComponent(GetComponent(0)).Owner.Components[i].ClassName);
      end;
     if (Dialog.List2.IndexOf(Designer.Form.ClassName)= -1)
     then Dialog.List2.Add(Designer.Form.ClassName);
     DeleteFromFirstIfNotInSecond(List1,List2);
     DeleteFromFirstIfInSecond(List2,List1);
     List1.EndUpdate;
     List2.EndUpdate;
     Execute;
     SetOrdValue(LongInt(List1));
    end;
   finally
    Dialog.Free;
   end;
  end;



end.
